using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Pens {
  /// <summary>
  /// Summary description for AlignmentsForm.
  /// </summary>
  public class AlignmentsForm : System.Windows.Forms.Form {
    /// <summary>
    /// Required designer variable.
    /// </summary>
    private System.ComponentModel.Container components = null;

    public AlignmentsForm() {
      //
      // Required for Windows Form Designer support
      //
      InitializeComponent();

      //
      // TODO: Add any constructor code after InitializeComponent call
      //
    }

    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    protected override void Dispose( bool disposing ) {
      if( disposing ) {
        if(components != null) {
          components.Dispose();
        }
      }
      base.Dispose( disposing );
    }

		#region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent() {
      // 
      // AlignmentsForm
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(8, 19);
      this.BackColor = System.Drawing.Color.DarkGray;
      this.ClientSize = new System.Drawing.Size(292, 266);
      this.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
      this.Name = "AlignmentsForm";
      this.Text = "Alignments";
      this.Paint += new System.Windows.Forms.PaintEventHandler(this.AlignmentsForm_Paint);

    }
		#endregion

    private void AlignmentsForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
      Graphics g = e.Graphics;
      string[] alignNames = Enum.GetNames(typeof(PenAlignment));
      Array.Sort(alignNames);

      int x = 0;
      int y = 0;
      int width = this.ClientRectangle.Width;
      int height = this.ClientRectangle.Height/2;
      Brush blackBrush = Brushes.Black;
      Pen redPen = System.Drawing.Pens.Red;

      foreach( string alignName in alignNames ) {
        using( Pen pen = new Pen(Color.White, 13) ) {
          pen.Alignment = (PenAlignment)Enum.Parse(typeof(PenAlignment), alignName);
          // Only two values supported
          if( pen.Alignment != PenAlignment.Center && pen.Alignment != PenAlignment.Inset ) continue;
          g.DrawEllipse(pen, x + 10, y + 10, width - 20, height - 20);
          g.DrawEllipse(redPen, x + 10, y + 10, width - 20, height - 20);
          StringFormat format = new StringFormat();
          format.Alignment = StringAlignment.Center;
          format.LineAlignment = StringAlignment.Center;
          g.DrawString(alignName, this.Font, blackBrush, new Rectangle(x, y, width, height), format);
          y += height;
        }
      }

    }
  }
}
